      SUBROUTINE UMAT(STRESS,STATEV,DDSDDE,SSE,SPD,SCD,
     1 RPL,DDSDDT,DRPLDE,DRPLDT,STRAN,DSTRAN,
     2 TIME,DTIME,TEMP,DTEMP,PREDEF,DPRED,MATERL,NDI,NSHR,NTENS,
     3 NSTATV,PROPS,NPROPS,COORDS,DROT,PNEWDT,CELENT,
     4 DFGRD0,DFGRD1,NOEL,NPT,KSLAY,KSPT,KSTEP,KINC)
C
      INCLUDE 'ABA_PARAM.INC'
C
      CHARACTER*8 MATERL


      DIMENSION STRESS(NTENS),STATEV(NSTATV),
     1 DDSDDE(NTENS,NTENS),DDSDDT(NTENS),DRPLDE(NTENS),
     2 STRAN(NTENS),DSTRAN(NTENS),DFGRD0(3,3),DFGRD1(3,3),
     3 TIME(2),PREDEF(1),DPRED(1),PROPS(NPROPS),COORDS(3),DROT(3,3)

C

C    LOCAL ARRAYS      

	DIMENSION RCauchy(3,3),RF(3,3),RFTr(3,3)
      DIMENSION RAA(3,3),RBB(3,3)
      DIMENSION RI2(3,3)      
      DIMENSION RG_0(3,3)
      DIMENSION RG(3,3), RGInv(3,3)
      DIMENSION RGInvF(3,3), RGInvFG_0(3,3), RGInvFG_0RFTr(3,3)
      
      DIMENSION RC4(3,3,3,3)
C
C ----------------------------------------------------------------
C    CANNOT BE USED FOR PLANE STRESS
C ----------------------------------------------------------------
c     matrix properties
      RYoung=PROPS(1)
      RPoisson=PROPS(2)
c     RL0 = 2.778
      RL0=PROPS(3)
	Rmu=RYoung/(2.d0*(RPoisson+1.d0))
	RBulk=2.d0*Rmu*(1.d0+RPoisson)/(3.d0*(1.d0-2.d0*RPoisson))
c -----------------------------------------------------------------
c     Calculate g and g0
c     Initial director direction is along x
c     Arbitrary direction of initial director can be achieved by defining local coordinate systems.     
      RG_0(1,1) = RL0
      RG_0(2,2) = 1.d0/SQRT(RL0)
      RG_0(3,3) = 1.d0/SQRT(RL0)
      RG_0(1,2) = 0.d0
      RG_0(1,3) = 0.d0
      RG_0(2,1) = 0.d0
      RG_0(2,3) = 0.d0
      RG_0(3,1) = 0.d0
      RG_0(3,2) = 0.d0
      
      RL = 1.d0 + (RL0-1.d0) * (120.d0 - (TEMP+DTEMP))/60.d0
      RGP = RL
      RGO = 1.d0/SQRT(RL)   
      
      RI2(1,1) = 1.d0
      RI2(2,2) = 1.d0
      RI2(3,3) = 1.d0
      RI2(1,2) = 0.d0
      RI2(1,3) = 0.d0
      RI2(2,1) = 0.d0
      RI2(2,3) = 0.d0
      RI2(3,1) = 0.d0
      RI2(3,2) = 0.d0
c--------------------------------------------------------------------
c     calculate some tensors
      RF = DFGRD1
      CALL KTENSAA(RF,RG_0,RI2,RAA)
      CALL KTENSBB(RF,RG_0,RI2,RBB)
c--------------------------------------------------------------------
c     calculate the SSE (strain elastic energy)
      CALL KTRANS(RF,RFTr)
      CALL KDETERM(RF,RJ)
      RG(1,1) = RGO + (RGP-RGO)*RF(1,1)*RF(1,1)/
     C(RF(1,1)**2 + RF(2,1)**2 + RF(3,1)**2)
      
      RG(2,2) = RGO + (RGP-RGO)*RF(2,1)*RF(2,1)/
     C(RF(1,1)**2 + RF(2,1)**2 + RF(3,1)**2)
      
      RG(3,3) = RGO + (RGP-RGO)*RF(3,1)*RF(3,1)/
     C(RF(1,1)**2 + RF(2,1)**2 + RF(3,1)**2)
      
      RG(1,2) = (RGP-RGO)*RF(1,1)*RF(2,1)/
     C(RF(1,1)**2 + RF(2,1)**2 + RF(3,1)**2)
      
      RG(1,3) = (RGP-RGO)*RF(1,1)*RF(3,1)/
     C(RF(1,1)**2 + RF(2,1)**2 + RF(3,1)**2)
      
      RG(2,1) = (RGP-RGO)*RF(2,1)*RF(1,1)/
     C(RF(1,1)**2 + RF(2,1)**2 + RF(3,1)**2)
      
      RG(2,3) = (RGP-RGO)*RF(2,1)*RF(3,1)/
     C(RF(1,1)**2 + RF(2,1)**2 + RF(3,1)**2)
      
      RG(3,1) = (RGP-RGO)*RF(3,1)*RF(1,1)/
     C(RF(1,1)**2 + RF(2,1)**2 + RF(3,1)**2)
      
      RG(3,2) = (RGP-RGO)*RF(3,1)*RF(2,1)/
     C(RF(1,1)**2 + RF(2,1)**2 + RF(3,1)**2)
      
      CALL KINVERT(RG,RGInv)
      CALL KMULT(RGInv,RF,RGInvF)
      CALL KMULT(RGInvF,RG_0,RGInvFG_0)
      CALL KMULT(RGInvFG_0,RFTr,RGInvFG_0RFTr)
      SSE = Rmu/2*(RGInvFG_0RFTr(1,1)+RGInvFG_0RFTr(2,2)+
     C    RGInvFG_0RFTr(3,3) - 3) + RBulk/2*(RJ-1)**2 - 
     C    Rmu*LOG(RJ)     
C-------------------------------------------------------------------
C     Solving the cauchy stress
c-------------------------------------------------------------------
      CALL KStressLCE(RF,Rmu,RBulk,RG_0,RGP,RGO,RI2,RAA,RBB,RCauchy)
C	WRITE(7,*)'RCauchy',RCauchy
	STRESS(1)=RCauchy(1,1)
	STRESS(2)=RCauchy(2,2)
	STRESS(3)=RCauchy(3,3)
	STRESS(4)=RCauchy(1,2)
      IF (NTENS.EQ.6)THEN
	  STRESS(5)=RCauchy(1,3)
	  STRESS(6)=RCauchy(2,3)
	ENDIF
c ------------------------------------------------------------------
c     Calculation of the Jacobian
c-------------------------------------------------------------------
      CALL JACOBLCE(RF,Rmu,RBulk,RG_0,RGP,RGO,RI2,RAA,RBB,RCauchy,RC4)
c     reorganize 4th order jacobian tensor into matrix
	CALL condenseETens(RC4, NDI, NSHR, NTENS, DDSDDE)
c     WRITE(7,*)'DDSDDE',DDSDDE
c	CALL XIT  
	RETURN
	END

c=====/================================================================/    




!*********************************************************
c----------------------------------------------------------------------
c     Calculation of the stress in the LCE material
c---------------------------------------------------------------------

      SUBROUTINE KStressLCE(RF,Rmu,RBulk,RG_0,RGP,RGO,RI2,RAA,RBB,RS)

	INCLUDE 'ABA_PARAM.INC'  
      
	DIMENSION RS(3,3),RF(3,3),RFTr(3,3)
	DIMENSION RG_0(3,3)
      DIMENSION RAA(3,3),RBB(3,3)
      DIMENSION RCC(3,3),RCFTr(3,3)
      DIMENSION RI2(3,3)

c     J=def(F)
	CALL KDETERM(RF,RJ)
      CALL KTRANS(RF,RFTr)  
c     calculate C
      CALL KTENSCC(RF,RG_0,RGP,RGO,RAA,RBB,RCC)
      CALL KMULT(RCC,RFTr,RCFTr)

      RS=Rmu/2.d0/RJ/RGO*RCFTr + RBulk*(RJ-1.d0)*RI2 - Rmu/RJ*RI2
	RETURN
	END



c=====/================================================================/    
C                   
      SUBROUTINE KDETERM(RA,RdetA)                                               
C                   
C     KDETERM(A,d): CALCULATES THE DETERMINANT, d, OF MATRIX A(3,3)         
C                   
C                   
C     variables used:                                                       
C     A = INPUT tensor                                                
C     d = scalar value of determinant                                 
C                   
C     SUBROUTINE CALLS: - none                                              
C                   
C-----/----------------------------------------------------------------/    
      INCLUDE 'ABA_PARAM.INC'                                               
      DIMENSION RA(3,3)                                                      
                    
      RdetA=  RA(1,1)*(RA(2,2)*RA(3,3) - RA(2,3)*RA(3,2))                           
     1    -RA(1,2)*(RA(2,1)*RA(3,3) - RA(2,3)*RA(3,1))                           
     2    +RA(1,3)*(RA(2,1)*RA(3,2) - RA(2,2)*RA(3,1))  
                              
      RETURN        
      END 

c=====/================================================================/    
      SUBROUTINE KMULT(RA,RB,RC)                                                                   
C                   
C     variables used:                                                       
C     RC=RA*RB                                               
C-----/----------------------------------------------------------------/    
      INCLUDE 'ABA_PARAM.INC'                                               
      DIMENSION RA(3,3),RB(3,3),RC(3,3)


	                                                                                                    
        RC(1,1)=RA(1,1)*RB(1,1)+RA(1,2)*RB(2,1)+RA(1,3)*RB(3,1)                        
        RC(1,2)=RA(1,1)*RB(1,2)+RA(1,2)*RB(2,2)+RA(1,3)*RB(3,2)                         
        RC(1,3)=RA(1,1)*RB(1,3)+RA(1,2)*RB(2,3)+RA(1,3)*RB(3,3)
	                              
        RC(2,1)=RA(2,1)*RB(1,1)+RA(2,2)*RB(2,1)+RA(2,3)*RB(3,1)                          
        RC(2,2)=RA(2,1)*RB(1,2)+RA(2,2)*RB(2,2)+RA(2,3)*RB(3,2)                            
        RC(2,3)=RA(2,1)*RB(1,3)+RA(2,2)*RB(2,3)+RA(2,3)*RB(3,3)
	                            
        RC(3,1)=RA(3,1)*RB(1,1)+RA(3,2)*RB(2,1)+RA(3,3)*RB(3,1)                           
        RC(3,2)=RA(3,1)*RB(1,2)+RA(3,2)*RB(2,2)+RA(3,3)*RB(3,2)                          
        RC(3,3)=RA(3,1)*RB(1,3)+RA(3,2)*RB(2,3)+RA(3,3)*RB(3,3) 
                        
C                   
      RETURN        
      END 
c=====/================================================================/    
C                   
      SUBROUTINE KTRANS(RA,RAT)                                               
C                   
C     RAT=transpose(RA)                                                                      
C                   
C-----/----------------------------------------------------------------/    
      INCLUDE 'ABA_PARAM.INC'                                               
      DIMENSION RA(3,3),RAT(3,3)                                                      
                    
      RAT(1,1)=RA(1,1)
	RAT(1,2)=RA(2,1)
	RAT(1,3)=RA(3,1)
	RAT(2,1)=RA(1,2)
	RAT(2,2)=RA(2,2)
	RAT(2,3)=RA(3,2)
	RAT(3,1)=RA(1,3)
	RAT(3,2)=RA(2,3)
	RAT(3,3)=RA(3,3)
                          
      RETURN        
      END  

c=====/================================================================/
c=====/================================================================/

c=====/================================================================/    
      SUBROUTINE KINVERT(RA,RB)                                          
C                   
C     KINVERT(A,detA,B): CALCULATES THE INVERSE OF MATRIX A(3,3)            
C                        WHICH HAS DETERMINANT detA (INPUT PARAMETER)       
C 			           AND STORES THE RESULT IN MATRIX B = A^(-1)                            
C                   
C     variables used:                                                       
C     A    = INPUT tensor                                                
C     detA = INPUT scalar, determinant (A)                               
C     B    = OUTPUT :inverse of input tensor                             
C                   
C     SUBROUTINE CALLS: - none                                              
C                   
C-----/----------------------------------------------------------------/    
      INCLUDE 'ABA_PARAM.INC'                                               
      DIMENSION RA(3,3),RB(3,3)
	
	  CALL KDETERM(RA,RdetA)                                               
                    
        Rdi=1.0/RdetA                                                         
        RB(1,1)=(RA(2,2)*RA(3,3)-RA(3,2)*RA(2,3))*Rdi                             
        RB(2,2)=(RA(1,1)*RA(3,3)-RA(3,1)*RA(1,3))*Rdi                             
        RB(3,3)=(RA(1,1)*RA(2,2)-RA(2,1)*RA(1,2))*Rdi                             
        RB(1,2)=(RA(3,2)*RA(1,3)-RA(1,2)*RA(3,3))*Rdi                             
        RB(1,3)=(RA(1,2)*RA(2,3)-RA(2,2)*RA(1,3))*Rdi                             
        RB(2,3)=(RA(2,1)*RA(1,3)-RA(1,1)*RA(2,3))*Rdi                             
        RB(2,1)=(RA(3,1)*RA(2,3)-RA(2,1)*RA(3,3))*Rdi                             
        RB(3,1)=(RA(2,1)*RA(3,2)-RA(3,1)*RA(2,2))*Rdi                             
        RB(3,2)=(RA(3,1)*RA(1,2)-RA(1,1)*RA(3,2))*Rdi                             
C                   
      RETURN        
      END 
c=====/================================================================/    
      SUBROUTINE KTENSPROD(RA,RB,RC)  
	
c     tensor product                                                                 
                   
C     variables used:  
c     RC  fourth order tensor                                                     
C     RC=RA*RB  
c     RC_ijkl= RA_ij RC_kl                                             
C-----/----------------------------------------------------------------/    
      INCLUDE 'ABA_PARAM.INC'   
	DIMENSION RA(3,3),RB(3,3),RC(3,3,3,3) 

	RC=0.d00

	DO II=1,3
	  DO IJ=1,3
	    DO IK=1,3
	      DO IL=1,3

	         RC(II,IJ,IK,IL)=RA(II,IJ)*RB(IK,IL)

	      ENDDO
	    ENDDO
	  ENDDO
	ENDDO

	RETURN
	END
c=====/================================================================/   
 
      SUBROUTINE KTENSAA(RF,RG_0,RI2,RAA)                                                                   
C                   
C                                                            
C                                                 
C-----/----------------------------------------------------------------/    
      INCLUDE 'ABA_PARAM.INC'                                               
      DIMENSION RF(3,3),RG_0(3,3),RAA(3,3)
      DIMENSION RI2(3,3)
      
      RAA=0.d0
      
      DO Ix=1,3
          DO Iy=1,3
              DO Ii=1,3
                  DO Ij=1,3
                      DO Ik=1,3
                          DO Il=1,3
                              RAA(Ix,Iy) = RAA(Ix,Iy) + 
     CRI2(Ii,Ix)*RI2(1,Iy)*RF(Ii,Ij)*RG_0(Ij,Ik)*RF(Il,Ik)*RF(Il,1)+
     CRF(Ii,1)*RI2(Ii,Ix)*RI2(Ij,Iy)*RG_0(Ij,Ik)*RF(Il,Ik)*RF(Il,1)+
     CRF(Ii,1)*RF(Ii,Ij)*RG_0(Ij,Ik)*RI2(Il,Ix)*RI2(Ik,Iy)*RF(Il,1)+
     CRF(Ii,1)*RF(Ii,Ij)*RG_0(Ij,Ik)*RF(Il,Ik)*RI2(Il,Ix)*RI2(1,Iy)
                          END DO
                      END DO
                  END DO
              END DO
          END DO
      END DO
      RETURN 
      END
c=====/================================================================/    
      SUBROUTINE KTENSBB(RF,RG_0,RI2,RBB)                                                                   
C                   
C                                                            
C                                                 
C-----/----------------------------------------------------------------/    
      INCLUDE 'ABA_PARAM.INC'                                               
      DIMENSION RF(3,3),RG_0(3,3),RBB(3,3)
      DIMENSION RI2(3,3),RFTr(3,3),RFTrF(3,3)
      
      CALL KTRANS(RF,RFTr)
      CALL KMULT(RFTr,RF,RFTrF) 
      RBB=0.d0
      
      DO Ix=1,3
          DO Iy=1,3
              RBB(Ix,Iy) = 
     C - 1.d0/((RFTrF(1,1))**2)*2.d0*RI2(1,Iy)*RF(Ix,1)
          END DO
      END DO
      
      RETURN 
      END
c=====/================================================================/    
      SUBROUTINE KTENSCC(RF,RG_0,RGP,RGO,RAA,RBB,RCC)                                                                  
C                   
C                                                            
C                                                 
C-----/----------------------------------------------------------------/    
      INCLUDE 'ABA_PARAM.INC'                                               
      DIMENSION RF(3,3),RG_0(3,3),RCC(3,3)
      DIMENSION RFTr(3,3),RFTrF(3,3),
     CRFTrFG(3,3),RFTrFGFTrF(3,3),RFG(3,3)
      DIMENSION RAA(3,3),RBB(3,3)

      CALL KTRANS(RF,RFTr)
      CALL KMULT(RFTr,RF,RFTrF)
      CALL KMULT(RFTrF,RG_0,RFTrFG)
      CALL KMULT(RFTrFG,RFTrF,RFTrFGFTrF)
      CALL KMULT(RF,RG_0,RFG)
      RCC = 2*RFG - 
     C(1-RGO/RGP)*(RAA*1.d0/(RFTrF(1,1)) + RBB*RFTrFGFTrF(1,1))
      
      RETURN 
      END
c=====/================================================================/    
      SUBROUTINE KTENS45(RF,Rmu,RBulk,RI2,RTens45)
C-----/----------------------------------------------------------------/    
      INCLUDE 'ABA_PARAM.INC' 
      DIMENSION RF(3,3),RFTr(3,3),RFINVTr(3,3)
      DIMENSION RI2(3,3)
      DIMENSION RTens45(3,3,3,3)
      
      CALL KTRANS(RF,RFTr)
      CALL KDETERM(RF,RJ)
      CALL KINVERT(RFTr,RFINVTr)
      CALL KTENSPROD(RI2,RFINVTr,RTens45)
      
      RTens45 = RTens45*(RBulk*RJ+Rmu/RJ)
      RETURN
      END                                           
C-----/----------------------------------------------------------------/

c=====/================================================================/    
      SUBROUTINE KTENS1(RF,Rmu,RBulk,RG_0,RGP,RGO,RI2,RTens1)
C-----/----------------------------------------------------------------/    
      INCLUDE 'ABA_PARAM.INC' 
      DIMENSION RF(3,3),RFTr(3,3),RFINVTr(3,3)
      DIMENSION RI2(3,3)
      DIMENSION RG_0(3,3),RFG(3,3),RFGFTr(3,3)
      DIMENSION RTens1(3,3,3,3),RTens1A(3,3,3,3),RTens1L(3,3,3,3)
      
      CALL KTRANS(RF,RFTr)
      CALL KINVERT(RFTr,RFINVTr)
      CALL KDETERM(RF,RJ)
      CALL KMULT(RF,RG_0,RFG)
      CALL KMULT(RFG,RFTr,RFGFTr)
      
      CALL KTENSPROD(RFGFTr,RFINVTr,RTens1L)
      RTens1L = - Rmu/RJ/RGO*RTens1L
      CALL KTENS1A(RF,RG_0,RI2,RTens1A)
      RTens1A = Rmu/RJ/RGO*RTens1A
      RTens1 = RTens1L + RTens1A

      RETURN
      END                                           
C-----/----------------------------------------------------------------/c=====/================================================================/    
      SUBROUTINE KTENS1A(RF,RG_0,RI2,RTens1A)
C-----/----------------------------------------------------------------/    
      INCLUDE 'ABA_PARAM.INC' 
      DIMENSION RF(3,3),RG_0(3,3)
      DIMENSION RI2(3,3)
      DIMENSION RTens1A(3,3,3,3)
      RTens1A=0.d00
      DO Ii=1,3
          DO Ij=1,3
              DO Ip=1,3
                  DO Iq=1,3
                      DO Ik=1,3
                          DO Im=1,3
                              RTens1A(Ii,Ij,Ip,Iq)=RTens1A(Ii,Ij,Ip,Iq)+
     cRI2(Ii,Ip)*RI2(Ik,Iq)*RG_0(Ik,Im)*RF(Ij,Im) + 
     cRF(Ii,Ik)*RG_0(Ik,Im)*RI2(Ij,Ip)*RI2(Im,Iq)
                          END DO
                      END DO
                  END DO
              END DO
          END DO
      END DO
      RETURN
      END                                           
C-----/----------------------------------------------------------------/      
c=====/================================================================/    
      SUBROUTINE KTENS2(RF,Rmu,RBulk,RG_0,RGP,RGO,RI2,RAA,RBB,RTens2)
C-----/----------------------------------------------------------------/    
      INCLUDE 'ABA_PARAM.INC' 
      DIMENSION RF(3,3),RFTr(3,3),RFINVTr(3,3),RFTrF(3,3)
      DIMENSION RI2(3,3)
      DIMENSION RG_0(3,3)
      DIMENSION RAA(3,3),RBB(3,3)
      DIMENSION RAAFTr(3,3)
      DIMENSION RTens2(3,3,3,3),RTens2A(3,3,3,3),RTens2L(3,3,3,3)
      DIMENSION RTens2M(3,3,3,3)
      
      CALL KTRANS(RF,RFTr)
      CALL KINVERT(RFTr,RFINVTr)
      CALL KDETERM(RF,RJ)
      CALL KMULT(RFTr,RF,RFTrF)
      CALL KMULT(RAA,RFTr,RAAFTr)
      
      CALL KTENSPROD(RAAFTr,RFINVTr,RTens2L)
      RTens2L = - Rmu/RGO*(1.d0-RGO/RGP)/2.d0/RJ/RFTrF(1,1)*RTens2L
      
      CALL KTENSPROD(RAAFTr,RBB,RTens2M)
      RTens2M = Rmu/RGO*(1.d0-RGO/RGP)/2.d0/RJ*RTens2M
      
      CALL KTENS2A(RF,RG_0,RI2,RTens2A)
      
      RTens2A = Rmu/RGO*(1.d0-RGO/RGP)/2.d0/RJ/RFTrF(1,1)*RTens2A
      
      RTens2 = RTens2L + RTens2M + RTens2A
      RETURN
      END 
C-----/----------------------------------------------------------------/c=====/================================================================/    
      SUBROUTINE KTENS2A(RF,RG_0,RI2,RTens2A)
C-----/----------------------------------------------------------------/    
      INCLUDE 'ABA_PARAM.INC' 
      DIMENSION RF(3,3),RG_0(3,3)
      DIMENSION RI2(3,3)
      DIMENSION RTens2A(3,3,3,3)
      RTens2A=0.d00
      DO Indx=1,3
          DO Indz=1,3
              DO Indm=1,3
                  DO Indn=1,3
                      DO Ii=1,3
                          DO Ij=1,3
                              DO Ik=1,3
                                  DO Il=1,3
                                      DO Iy=1,3
                                          RTens2A(Indx,Indz,Indm,Indn)= 
     cRTens2A(Indx,Indz,Indm,Indn)+ 
     BRI2(Ii,Indx)*RI2(1,Iy)*RI2(Ii,Indm)*RI2(Ij,Indn)*RG_0(Ij,Ik)*
     BRF(Il,Ik)*RF(Il,1)*RF(Indz,Iy)+
     BRI2(Ii,Indx)*RI2(1,Iy)*RF(Ii,Ij)*RG_0(Ij,Ik)*RI2(Il,Indm)*
     BRI2(Ik,Indn)*RF(Il,1)*RF(Indz,Iy)+
     BRI2(Ii,Indx)*RI2(1,Iy)*RF(Ii,Ij)*RG_0(Ij,Ik)*RF(Il,Ik)*
     BRI2(Il,Indm)*RI2(1,Indn)*RF(Indz,Iy)+
     BRI2(Ii,Indx)*RI2(1,Iy)*RF(Ii,Ij)*RG_0(Ij,Ik)*RF(Il,Ik)*
     BRF(Il,1)*RI2(Indz,Indm)*RI2(Iy,Indn)+
     CRI2(Ii,Indm)*RI2(1,Indn)*RI2(Ii,Indx)*RI2(Ij,Iy)*RG_0(Ij,Ik)*
     CRF(Il,Ik)*RF(Il,1)*RF(Indz,Iy)+
     CRF(Ii,1)*RI2(Ii,Indx)*RI2(Ij,Iy)*RG_0(Ij,Ik)*RI2(Il,Indm)*
     CRI2(Ik,Indn)*RF(Il,1)*RF(Indz,Iy)+
     CRF(Ii,1)*RI2(Ii,Indx)*RI2(Ij,Iy)*RG_0(Ij,Ik)*RF(Il,Ik)*
     CRI2(Il,Indm)*RI2(1,Indn)*RF(Indz,Iy)+
     CRF(Ii,1)*RI2(Ii,Indx)*RI2(Ij,Iy)*RG_0(Ij,Ik)*RF(Il,Ik)*
     CRF(Il,1)*RI2(Indz,Indm)*RI2(Iy,Indn)+  
     DRI2(Ii,Indm)*RI2(1,Indn)*RF(Ii,Ij)*RG_0(Ij,Ik)*RI2(Il,Indx)*
     DRI2(Ik,Iy)*RF(Il,1)*RF(Indz,Iy)+                                
     DRF(Ii,1)*RI2(Ii,Indm)*RI2(Ij,Indn)*RG_0(Ij,Ik)*RI2(Il,Indx)*
     DRI2(Ik,Iy)*RF(Il,1)*RF(Indz,Iy)+                        
     DRF(Ii,1)*RF(Ii,Ij)*RG_0(Ij,Ik)*RI2(Il,Indx)*RI2(Ik,Iy)*
     DRI2(Il,Indm)*RI2(1,Indn)*RF(Indz,Iy)+              
     DRF(Ii,1)*RF(Ii,Ij)*RG_0(Ij,Ik)*RI2(Il,Indx)*RI2(Ik,Iy)*
     DRF(Il,1)*RI2(Indz,Indm)*RI2(Iy,Indn)+                      
     ERI2(Ii,Indm)*RI2(1,Indn)*RF(Ii,Ij)*RG_0(Ij,Ik)*RF(Il,Ik)*
     ERI2(Il,Indx)*RI2(1,Iy)*RF(Indz,Iy)+                     
     ERF(Ii,1)*RI2(Ii,Indm)*RI2(Ij,Indn)*RG_0(Ij,Ik)*RF(Il,Ik)*
     ERI2(Il,Indx)*RI2(1,Iy)*RF(Indz,Iy)+    
     ERF(Ii,1)*RF(Ii,Ij)*RG_0(Ij,Ik)*RI2(Il,Indm)*RI2(Ik,Indn)*
     ERI2(Il,Indx)*RI2(1,Iy)*RF(Indz,Iy)+                           
     ERF(Ii,1)*RF(Ii,Ij)*RG_0(Ij,Ik)*RF(Il,Ik)*RI2(Il,Indx)*
     ERI2(1,Iy)*RI2(Indz,Indm)*RI2(Iy,Indn)
                                      END DO
                                  END DO
                              END DO
                          END DO
                      END DO
                  END DO
              END DO
          END DO
      END DO
      RETURN
      END                                           
C-----/----------------------------------------------------------------/
c=====/================================================================/    
      SUBROUTINE KTENS3(RF,Rmu,RBulk,RG_0,RGP,RGO,RI2,RAA,RBB,RTens3)
C-----/----------------------------------------------------------------/    
      INCLUDE 'ABA_PARAM.INC' 
      DIMENSION RF(3,3),RFTr(3,3),RFINVTr(3,3),RFTrF(3,3)
      DIMENSION RFTrFG(3,3),RFTrFGFTrF(3,3)
      DIMENSION RI2(3,3)
      DIMENSION RG_0(3,3)
      DIMENSION RAA(3,3),RBB(3,3)
      DIMENSION RBBFTr(3,3)
      DIMENSION RTens3(3,3,3,3),RTens3A(3,3,3,3),RTens3L(3,3,3,3)
      DIMENSION RTens3M(3,3,3,3)
      
      CALL KTRANS(RF,RFTr)
      CALL KINVERT(RFTr,RFINVTr)
      CALL KDETERM(RF,RJ)
      CALL KMULT(RFTr,RF,RFTrF)
      CALL KMULT(RFTrF,RG_0,RFTrFG)
      CALL KMULT(RFTrFG,RFTrF,RFTrFGFTrF)
      CALL KMULT(RBB,RFTr,RBBFTr)
      
      CALL KTENSPROD(RBBFTr,RFINVTr,RTens3L)
      RTens3L = - Rmu/RGO*(1.d0-RGO/RGP)/2.d0/RJ*RFTrFGFTrF(1,1)*RTens3L
      
      CALL KTENSPROD(RBBFTr,RAA,RTens3M)
      RTens3M = Rmu/RGO*(1.d0-RGO/RGP)/2.d0/RJ*RTens3M
      
      CALL KTENS3A(RF,RG_0,RI2,RTens3A)
      
      RTens3A = Rmu/RGO*(1.d0-RGO/RGP)/2.d0/RJ*RFTrFGFTrF(1,1)*RTens3A
      
      RTens3 = RTens3L + RTens3M + RTens3A
      RETURN
      END 
C-----/----------------------------------------------------------------/c=====/================================================================/    
      SUBROUTINE KTENS3A(RF,RG_0,RI2,RTens3A)
C-----/----------------------------------------------------------------/    
      INCLUDE 'ABA_PARAM.INC' 
      DIMENSION RF(3,3),RFTr(3,3),RFTrF(3,3),RG_0(3,3)
      DIMENSION RI2(3,3)
      DIMENSION RTens3A(3,3,3,3)
      DIMENSION RTens3B(3,3),RTens3D(3,3)
      DIMENSION RTens3C(3,3,3,3)
      DIMENSION RTens3AL(3,3,3,3),RTens3AR(3,3,3,3)
      RTens3A=0.d00
      RTens3B=0.d00
      RTens3D=0.d00
      RTens3C=0.d00
      RTens3AL=0.d00
      RTens3AR=0.d00
      CALL KTRANS(RF,RFTr)
      CALL KMULT(RFTr,RF,RFTrF)
      
      DO Indm=1,3
          DO Indn=1,3
              RTens3B(Indm,Indn) = RI2(1,Indn)*RF(Indm,1)
          END DO
      END DO
      RTens3B = -4/(RFTrF(1,1))**3*RTens3B
      
      DO Indx=1,3
          DO Indz=1,3
              DO Indm=1,3
                  DO Indn=1,3
                      RTens3C(Indx,Indz,Indm,Indn) = 
     CRI2(Indx,Indm)*RI2(1,Indn)*RF(Indz,1)+
     CRF(Indx,1)*RI2(Indz,Indm)*RI2(1,Indn)
                  END DO
              END DO
          END DO
      END DO
      RTens3AR = -2/(RFTrF(1,1))**2*RTens3C
      
      DO Indx=1,3
          DO Indz=1,3
              RTens3D(Indx,Indz) = RF(Indx,1)*RF(Indz,1)
          END DO
      END DO
      
      CALL KTENSPROD(RTens3D,RTens3B,RTens3AL)
      RTens3AL = -2*RTens3AL
      RTens3A = RTens3AL + RTens3AR
      
      RETURN
      END                                           
C-----/----------------------------------------------------------------/
!-----------------------------------------------------------------------
      SUBROUTINE condenseETens(cc4, NDI, NSHR, NTENS, DDSDDE)
!     reorganize 4th order elasticity tensor into matrix

      INCLUDE 'ABA_PARAM.INC'                        
      DIMENSION cc4(3,3,3,3), DDSDDE(NTENS,NTENS), 
     & idx1ik(6), idx1jl(6), idx2ik(6), idx2jl(6)
      
      DATA idx1ik / 1,2,3,1,1,2 /, 
     &     idx1jl / 1,2,3,2,3,3 /,
     &     idx2ik / 1,2,3,2,3,3 /,
     &     idx2jl / 1,2,3,1,1,2 /
      
      
      do I = 1, NTENS
        do J = 1, NTENS
           DDSDDE(I,J) = ( cc4(idx1ik(I),idx1jl(I),idx1ik(J),idx1jl(J))
     &               + cc4(idx2ik(I),idx2jl(I),idx2ik(J),idx2jl(J)) )
     &             * 0.5d0
        end do
      end do
         
      RETURN
      END                  
                        
!-----------------------------------------------------------------------  
c=====/================================================================    
	SUBROUTINE JACOBLCE(RF,Rmu,RBulk,RG_0,RGP,RGO,RI2,RAA,RBB,RS,RC4)
c                   
c	calculates material jacobian for the isotropic matrix                                                                   
c    
      INCLUDE 'ABA_PARAM.INC'                                             
c---                
c	variables in argument                                                     
c---                
	DIMENSION  RF(3,3),RG_0(3,3),RI2(3,3),RAA(3,3),RBB(3,3),RS(3,3)
      DIMENSION  RC4(3,3,3,3)

c                   
c---                
c	local variables   
c---                
c	                  
      DIMENSION RFTr(3,3),RFINVTr(3,3)
      DIMENSION RTens1(3,3,3,3),RTens2(3,3,3,3),RTens3(3,3,3,3)
      DIMENSION RTens45(3,3,3,3)
      DIMENSION RTensPSPF(3,3,3,3),RTensSFINVTrC(3,3,3,3)
      DIMENSION RTens(3,3,3,3),RTensRT(3,3,3,3)
      
      CALL KTRANS(RF,RFTr)
      CALL KINVERT(RFTr,RFINVTr)
      CALL KTENS45(RF,Rmu,RBulk,RI2,RTens45)
      CALL KTENS1(RF,Rmu,RBulk,RG_0,RGP,RGO,RI2,RTens1)
      CALL KTENS2(RF,Rmu,RBulk,RG_0,RGP,RGO,RI2,RAA,RBB,RTens2)
      CALL KTENS3(RF,Rmu,RBulk,RG_0,RGP,RGO,RI2,RAA,RBB,RTens3)
      
      RTensPSPF = RTens1 - RTens2 - RTens3 + RTens45
      
      CALL KTENSPROD(RS,RFINVTr,RTensSFINVTrC)
      RTens = RTensSFINVTrC + RTensPSPF
      
      CALL KRIGHTTRANS(RTens,RTensRT)
      
      CALL KINNERPROD(RTensRT,RFTr,RC4)
      
      
	RETURN             
	END
c=====/================================================================/    
C     	
	SUBROUTINE KRIGHTTRANS(RB,RBRT) 

c	RBRT= right transpose of (RB)
c      RBRT_ijlk=RB_ijkl
	
	INCLUDE 'ABA_PARAM.INC'                                               
      DIMENSION RB(3,3,3,3),RBRT(3,3,3,3)   
	
	RBRT=0.d00

	DO II=1,3
	  DO IJ=1,3
	    DO IK=1,3
	      DO IL=1,3

	         RBRT(II,IJ,IL,IK)=RB(II,IJ,IK,IL)

	      ENDDO
	    ENDDO
	  ENDDO
	ENDDO

	RETURN        
      END            
                    
c=====/================================================================/    

c=====/================================================================/  
      SUBROUTINE KINNERPROD(RB4,RA2,RC4)

c     inner tensor product  
c      RC4_ijnl=RB4_ijkl F_kn

      INCLUDE 'ABA_PARAM.INC'   
	DIMENSION RB4(3,3,3,3),RA2(3,3),RC4(3,3,3,3) 

	RC4=0.d00

	DO II=1,3
	  DO IJ=1,3
	    DO INN=1,3
	      DO IL=1,3

	         DO IK=1,3

	           RC4(II,IJ,INN,IL)=RC4(II,IJ,INN,IL)+
     *                            RB4(II,IJ,IK,IL)*RA2(IK,INN)

	         ENDDO

	      ENDDO
	    ENDDO
	  ENDDO
	ENDDO

	RETURN
	END

	
c=====/================================================================/